# If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
# The autodetection may work, but it probably won't in this case. Set to 0 by default.
# Override to 1 if you want the script to wing it, and hope it picks the right feature title.
+# Otherwise, you will need to rerun the script providing the feature title with the -t option.
trust_feature_title_autodetect_when_uncertain=0
###############################################
typeset debug=""
typeset dest=""
typeset isofile=""
+typeset vobfile=""
typeset dvdpath=""
typeset -i keep_intermediate_files=0
typeset -i make_final_dest_vob=0
echo >&2 "Options:"
echo >&2 " -d <destdir> Specify the destination directory to store the ripped DVD to"
echo >&2 " -n <dvdname> Specify what the name of the DVD is to process from $tmpdir"
- echo >&2 " If it is a full path to a DVD folder, it will be ripped instead of $dev"
+ echo >&2 " If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
+ echo >&2 " If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
echo >&2 " This is optional. If not specified, the dvd will be pulled from $dev"
echo >&2 " -m Make a mirror image of the DVD and save it as a DVD ISO file"
echo >&2 " The default operation is non-mirror mode where only the main"
dvdpath="$dvdname"
dvdname=`basename "$dvdname"`
if [ -z "$dvdname" ]; then
- fatal_and_exit "-E- Unable to extract dvdname from path: $dvdpath"
+ echo "-E- Unable to extract dvdname from path: $dvdpath"
+ exit 1
fi
if [ ! -d "$dvdpath/VIDEO_TS" ]; then
- fatal_and_exit "-E- You must supply a full path to a valid DVD folder with this option"
+ echo "-E- You must supply a full path to a valid DVD folder with this option"
+ exit 1
+ fi
+ fi
+ # check to see if dvdname is a full path to an MPG2 (VOB) file
+ # if it is, set dvdname and vobfile appropriately
+ if [ -f "$dvdname" ]; then
+ vobfile="$dvdname"
+ dvdname=`basename "$dvdname"`
+ file "$vobfile" | grep -q "MPEG"
+ if [ $? == 0 ]; then
+ # It is a valid MPEG2 file, now strip the extension off our dvdname
+ dvdname=${dvdname%.[^.]*}
+ else
+ echo "-E- Unsupported file type: $vobfile"
+ exit 1
fi
fi
ripdvd=0
exit 1
fi
+# make sure our vobfile value is set
+if [ -z "$vobfile" ]; then
+ vobfile="$dest/$dvdname.VOB"
+fi
+
# set up some variables to hold various logfiles
logfile="$logdir/$dvdname.log"
passlogfile="$tmpdir/divx2pass.log"
cat "$ddrescuelog" >> "$logfile"
else
# rip from a path instead
- make_dvd_iso_image_from_folder "$dvdpath" "$isofile"
- if [ ! -s "$isofile" ]; then
- fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
- fi
+ make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
fi
}
src="$1"
dst="$2"
+ handle_error=$3
echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
# make an iso image out of our directory
echo " mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
- if [ $? != 0 ]; then
- fatal_and_exit '-E- mkisofs -dvd-video "$src" | dd of="$dst" obs=32k seek=0 failed'
+
+ # make sure we were able to create the iso image from the folder given to us
+ if [ ! -s "$tmpdir/$dvdname.iso" ] && [ $handle_error -eq 1 ]; then
+ echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
+ echo " Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
+ # get the feature title from the DVD folder
+ get_feature_title "$dvdpath"
+ # create our main VOB file from the ISO
+ create_main_vob_with_mplayer "$dvdpath"
fi
}
}
function get_feature_title {
+ source="$1"
# if a feature title was given on the command line, use it
if [ $feature_title_override -ne 0 ]; then
feature_title=$feature_title_override
if [ $ripdvd -eq 1 ]; then
feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
else
- feature_title=`lsdvd "$isofile" | awk '/Longest/ { print $NF }'`
+ feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
fi
}
}
function create_main_vob_with_mplayer {
+
+ # argument processing
+ source="$1"
+ remove_dumplog=$2
+
# make sure we have a valid feature title
if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
fi
# use mplayer to create the main VOB file
- remove_dumplog=$1
- echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $dest/$dvdname.VOB" | tee -a "$logfile"
- echo " mplayer $lang_opts -dumpstream -dumpfile \"$dest/$dvdname.VOB\" -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
- mplayer $lang_opts -dumpstream -dumpfile "$dest/$dvdname.VOB" -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
+ echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
+ echo " mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
+ mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
if [ $? != 0 ]; then
cat $dumplog | grep -v "^A:" >> "$logfile"
fatal_and_exit "-E- Mplayer Failed"
[[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
# cat the giant VOB into mencoder to create a playable VOB file
- cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$dest/$dvdname.VOB" >> "$logfile" 2>&1
+ cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
if [ $? != 0 ]; then
fatal_and_exit "-E- Mencoder Failed"
fi
# detect this by seeing how much smaller the dst vob is from the src vob.
MAX_FILESIZE_DELTA_PERCENT=70
SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
- DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
+ DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
# Try one other way to get the VOB using mplayer directly to rip the feature titleset.
echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
- create_main_vob_with_mplayer
+ create_main_vob_with_mplayer "$isofile"
[[ -e "$dumplog" ]] && rm -f $dumplog
- DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
+ DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
if [ $? == 0 ]; then
# Try one other way to get the VOB using mplayer directly to rip the feature titleset.
echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
- create_main_vob_with_mplayer
+ create_main_vob_with_mplayer "$isofile"
grep -q "Too many video packets in the buffer:" $dumplog
if [ $? == 0 ]; then
[[ -e "$dumplog" ]] && rm -f $dumplog
MAX_ERRORS=10
ENDPOS=120
echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
- mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
+ mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
cat $dumplog | grep -v "^A:" >> "$logfile"
errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
if [ $errors -gt $MAX_ERRORS ]; then
echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
- create_main_vob_with_mplayer
+ create_main_vob_with_mplayer "$isofile"
echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
- mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
+ mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
if [ $? != 0 ]; then
cat $dumplog | grep -v "^A:" >> "$logfile"
fatal_and_exit "-E- Mplayer Failed"
function calculate_bitrate_from_target_size {
# determine what our bitrate needs to be if a target size was specified instead
if [ $target_size -ne 0 ]; then
- vob_length=`mplayer -identify -v "$dest/$dvdname.VOB" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
+ vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
((target_bitrate = (target_size * 1024 * 8) / vob_length ))
echo " With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
fi
echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
- if [ ! -e "$dest/$dvdname.VOB" ]; then
+ if [ ! -e "$vobfile" ]; then
# mplayer dumpstream does not work on DVDs that obscure the feature title.
# A DVD that has 99 titles, where the longest title isn't the main feature
# breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
# This can be detected by telling mplayer to parse the VOB file by copying its audio
# video streams to a dummy output file (/dev/null). Do that here to check for that
# problem before continuing.
- if [ -e "$dest/$dvdname.VOB" ]; then
+ if [ -e "$vobfile" ]; then
mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
- mencoder $mplayer_opts "$dest/$dvdname.VOB" -o "/dev/null" > $dumplog 2>&1
+ mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
grep -q "Too many audio packets in the buffer" $dumplog
if [ $? == 0 ]; then
echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
# Rip image from DVD path
if [ -n "$dvdpath" ]; then
echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
- make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso"
- if [ ! -s "$tmpdir/$dvdname.iso" ]; then
- fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
- fi
+ make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
fi
# make sure our isofile value is set
if [ -z "$isofile" ]; then
isofile="$tmpdir/$dvdname.iso"
fi
-
+
if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
- if [ ! -e "$dest/$dvdname.VOB" ]; then
- echo "-> Creating DVD video $dest/$dvdname.VOB" | tee -a "$logfile"
+ if [ ! -e "$vobfile" ]; then
+ echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
# get the feature title from the ISO
- get_feature_title
+ get_feature_title "$isofile"
# get the crop value from the ISO
get_crop_from_iso
get_audio_id_from_iso
# create our main VOB file from the ISO
- create_main_vob_with_mplayer
+ create_main_vob_with_mplayer "$isofile"
# remove the intermediate VOB file
remove_intermediate_vob_file
remove_intermediate_iso_file
else
- echo "-> Skipping VOB creation. VOB DVD video already exists: $dest/$dvdname.VOB" | tee -a "$logfile"
+ echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
fi
# transcode the DVD
for CH_OPTS in "${mencoder_audioch_opts[@]}";
do
echo -e " Encoding pass $PASS"
- echo -e "\n Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$dest/$dvdname.VOB\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
- mencoder $CH_OPTS $mencoder_opts_for_pass "$dest/$dvdname.VOB" -o "$output_file" > $encodelog 2>&1
+ echo -e "\n Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
+ mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
mencoder_retval=$?
grep -q "\[channels\] Invalid" $encodelog
if [ $? != 0 ]; then
done
if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
- [[ -e "$dest/$dvdname.VOB" ]] && rm -f "$dest/$dvdname.VOB";
+ [[ -e "$vobfile" ]] && rm -f "$vobfile";
[[ -e "$passlogfile" ]] && rm -f "$passlogfile";
else
- echo "-> Keeping VOB file: $dest/$dvdname.VOB" | tee -a "$logfile"
+ echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
echo "-> Keeping mencoder 2pass logfile: $passlogfile"
fi
fi
# add this video data to the mythtv DB
[ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi"
- [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.VOB"
+ [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile"
else
if [ $make_final_dest_iso -eq 1 ]; then
# make an iso image out of our directory
- make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso"
+ make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
# If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory
if [ -s "$dest/$dvdname.iso" ]; then